// gRgt_v
#pragma warning(disable:4996)
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define	DST_BUF_SIZE	2048
#define	ASC_BUF_MAX		512

char	bin2char(unsigned char);		// 0  15  '0'  'F' ɕϊ
void	ascbufclear(char*);				// ASCII\NA[
int		num_chk_hex(char* num_str);		// l`FbNiPUij
int		num_chk(char* num_str);			// l`FbN
int		hexatoi(char*);					// 16i񐔒lϊ
int		atoi2(char*, int*);				// 𐔒lɕϊi16iΉj

int		len;
int		i, dgtct;
char	c[16];
char	adr[32];
char	ascbuf[ASC_BUF_MAX];
char	dststr[DST_BUF_SIZE];

int main(int argc, char *argv[])
{
	FILE	*fpr;
	int		i, ic, start_adr, clm, flg;
	unsigned char	uc;
	long long		ll;
	int		ascofs;
	char*	fname;						// t@C
	errno_t	err;

	if (argc < 4) {
		printf("gRgt_vi\JnAhXAJwΉj\n");
		printf("g : %s [t@C] [\JnAhX] [J]\n", argv[0]);
		exit (1);
	}

	start_adr = atoi2(argv[2], &flg);	// 𐔒lɕϊi16iΉj
	if (!flg) {
		printf("\JnAhXsłi16iΉj : [%s]\n", argv[2]);
		exit (1);
	}

	clm = atoi2(argv[3], &flg);			// 𐔒lɕϊi16iΉj
	if (!flg) {
		printf("Jsłi16iΉj : [%s]\n", argv[3]);
		exit (1);
	}
	if (clm == 0 || clm > 256) {
		printf("J1ȏ256ȉɂĉ\n");
		exit (1);
	}

	fname = argv[1];					// t@C

	// t@CI[v
	err = fopen_s (&fpr, fname, "rb");
	if (err != 0) {
		printf ("t@C[hG[\n");
		printf (fname);
		printf ("\n");
		exit (1);
	}

	strcpy(ascbuf, ": ");				// d؂

	dststr[0] = 0;

	// KCh\
	printf("\n");
	printf("         ");
	for ( i = 0 ; i < clm ; i++ ) {
		printf("%02X ", i);
	}
	printf("\n");

	// d؂\
	for ( i = 0 ; i < (9+clm*3+2+clm) ; i++ ) {
		printf("-");
	}
	printf("\n");

	dgtct = 0;
	c[1] = 0;
	ascofs = 0;
	// t@C[h
	ll = (long long)start_adr;
	while (1) {
		if ((dgtct%clm) == 0) {
			sprintf(adr, "%08X ", ll);	// AhX
			strncat(dststr, adr, 10);
			ascbufclear(ascbuf);		// ASCII\NA[
		}
		// ASCIIR[hZbg
		ic = fgetc(fpr);
		if (ic == EOF) {
			break;
		}
		uc = (unsigned char)ic;
		if (0x20 <= uc && uc<= 0x7e) {
			if (uc == '%') {			// %
				ascbuf[ascofs+2] = uc;
				ascofs++;
				ascbuf[ascofs+2] = uc;
				ascofs++;
			} else {
				ascbuf[ascofs+2] = uc;
				ascofs++;
			}
		} else {
			ascbuf[ascofs+2] = '.';
			ascofs++;
		}
		c[0] = bin2char(uc/16);			// 
		strncat(dststr, c, 2);
		c[0] = bin2char(uc%16);			// 
		strncat(dststr, c, 2);
		c[0] = ' ';
		strncat(dststr, c, 2);
		dgtct++;
		if (dgtct >= clm) {
			dgtct = 0;
			strncat(dststr, ascbuf, ascofs+2);
			strncat(dststr, "\n", 2);
			printf (dststr);
			dststr[0] = 0;
			ascofs = 0;
		}
		ll++;
	}
	if ((dgtct%clm) != 0) {
		for ( i = 0 ; i < ((clm-(dgtct%clm))*3) ; i++ ) {
			strncat(dststr, " ", 2);
		}
		for ( i = 0 ; i < (clm-(dgtct%clm)) ; i++ ) {
			uc = ' ';
			ascbuf[i+2+(dgtct%clm)] = uc;
		}
		// Ō̍s̉sR[hȂ̂strncatOnullǉ
		uc = 0;
		ascbuf[i+2+(dgtct%clm)] = uc;
		strncat(ascbuf, "\n", 3);
		strncat(dststr, ascbuf, clm+2+3);
		printf (dststr);
	}

	// t@CN[Y
	if (fpr != NULL) {
		fclose(fpr);
	}
	exit (0);
}

// 0  15  '0'  'F' ɕϊ
char bin2char(unsigned char uc)
{
	char	c;
	if (uc <= 9) {
		c = '0'+uc;
	} else if (10 <= uc && uc <= 15) {
		c = 'A'+(uc-10);
	} else {
		c = '-'+uc;
		printf("ERROR - bin2char()\n");
	}
	return c;
}

// ASCII\NA[
void ascbufclear(char* ascbuf)
{
	memset(ascbuf, 0, sizeof(ascbuf));
	strcpy(ascbuf, ": ");				// d؂
}

// l`FbNiPUij
int num_chk_hex(char* num_str)
{
	int i, len, flg;
	unsigned char uc;
	flg = 0;
	len = strlen(num_str);
	for ( i = 0 ; i < len ; i++ ) {
		uc = num_str[i];
		if (!(('0' <= uc && uc <= '9') || 
			  ('A' <= uc && uc <= 'F') || 
			  ('a' <= uc && uc <= 'f'))) {
			flg = -1;
			break;
		}
	}
	return flg;
}

// l`FbN
int num_chk(char* num_str)
{
	int i, len, flg;
	unsigned char uc;
	flg = 0;
	len = strlen(num_str);
	for ( i = 0 ; i < len ; i++ ) {
		uc = num_str[i];
		if (!('0' <= uc && uc <= '9')) {
			flg = -1;
			break;
		}
	}
	return flg;
}

// 16i񐔒lϊ
int hexatoi(char* hexasc)
{
	int	i, len, iRet;
	unsigned char	uc;

	iRet = 0;

	len = strlen(hexasc);
	if (len == 0) {
		return iRet;
	}

	for ( i = 0 ; i < len ; i++ ) {
		uc = hexasc[i];
		if ('0' <= uc && uc <= '9') {
			iRet *= 16;
			iRet += uc - '0';
			continue;
		}
		if ('a' <= uc && uc <= 'f') {
			iRet *= 16;
			iRet += uc - 'a' + 10;
			continue;
		}
		if ('A' <= uc && uc <= 'F') {
			iRet *= 16;
			iRet += uc - 'A' + 10;
		}
	}

	return iRet;
}

// 𐔒lɕϊi16iΉj
int atoi2(char* asc, int* flg)
{
	int	len, hex_flg, err, iRet;

	hex_flg = 0;

	len = strlen(asc);
	if (len == 0) {
		*flg = 0;
		return 0;						// null ȂG[
	}

	if (strncmp(asc, "-", 1) == 0) {
		*flg = 0;
		return 0;						// }CiXȂG[
	}

	if (len >= 2) {
		if (strncmp(asc, "0x", 2) == 0 || 
			strncmp(asc, "0X", 2) == 0) {
			hex_flg = 1;
		}
	}

	if (hex_flg) {
		err = num_chk_hex(asc+2);		// l`FbNiPUij
		if (err == -1) {
			*flg = 0;
			return 0;
		}
		iRet = hexatoi(asc+2);			// 16i񐔒lϊ
	} else {
		err = num_chk(asc);				// l`FbN
		if (err == -1) {
			*flg = 0;
			return 0;
		}
		iRet = atoi(asc);
	}

	return iRet;
}
